open Flight;;

let a = 'a'
and b = 'a'
and n = int_of_float (sqrt (float_of_int nodes));;
(* int_of_string command_line.(1) *)

if n * n <> nodes then exit 2;;

let pair_if_int i = (i / n, i mod n)
and int_of_pair (i,j) = i * n + j;;

let north = max (local - n) (-1)
and east = if local mod n = 0 then (-1) else pred local;;
 
let corner = if north = (-1) or east = (-1) then (-1) else nodes - n - 1
and has d = (d <> (-1));;

let int_of_bool b = if b then 1 else 0;;

let rec lL() = 
  let nv,ev,cv = 
     sync(
       (if has(north) then get lL() from north else 0) ,
       (if has(east) then get lL() from east else 0), 
       (if has(corner) then get lL() from corner else 0) + (int_of_bool (a=b)) 
      )
    in max (max nv ev) cv;;

Printf.printf "Processus %d: %d\n" local (lL());;
flush stdout;;


close_Flight();;
